#!/bin/sh
#================================================= ==
# getkb - get translated ascii keys from K3 keyboard
# v1.2 by geekmaster
# STDOUT: pressed keys, until Enter key pressed.
#---------------------------------------------------
getkb() {
eips -z 2 38 # scroll
XP=0
YP=39
DN=/dev/null
KN="1234567890____qwertyuiop____asdfghjkl_____zxcvbnm_."
KS="1234567890____QWERTYUIOP____ASDFGHJKL_____ZXCVBNM_,"
KP="1234567890____~@#$%^&*()____<>[]{}?/\_____;:'|-+=_?" 
KM=$KN
ST=""
while :;do
eips $XP $YP "$ST""_ "
L="_"
set $(waitforkey); K=$1 D=$2
[[ $D -eq 0 ]]&& continue
# [[ $K -eq 28 ]]&& break # enter
[[ $K -eq 190 ]]&& break # use Aa for enter
[[ $K -eq 14 ]]&& ST="$(echo ${ST%?})" && continue # del
[[ $K -eq 42 ]]&& KM=$KS && continue # shift
[[ $K -eq 126 ]]&& KM=$KP && continue # Sym
[[ $K -eq 57 ]]&& L=" " # space
[[ $K -le 52 ]]&& L="$(echo \"$KM\"|cut -b$K-$K)"
# [[ "$L" == "_" ]]&& L="($K)"
[[ "$L" == "_" ]]&& continue
# echo -n "$L"
ST="$ST$L"
KM=$KN
done
echo "$ST"
}

putei() {
st=$1
ii=${#st}
while [ $ii -ge 0 ] 
do
eips -z 2 38 # scroll
eips 0 39 "$(echo $st | cut -b-50)" # write to the bottom
st="$(echo $st | cut -b51-)"
ii=$(( ii - 50 ))
done
}

killall -stop cvm launchpad 2> /dev/null 
HITCOUNT=0
FAILCOUNT=0
EXTLOC=/mnt/us/extensions/gameboy
FATLOC=/mnt/us/fbgnuboy
PROG=/mnt/us/fbgnuboy/fbgnuboy
cd $FATLOC
eips -c
putei "fbgnuboy - Games Boy Advanced Emulator"
putei ""
while [ "$HITCOUNT" -lt 1 ]
do
if [ !  -e "$PROG" ]  
then
putei "Errm? Oops. User FBGNUBOY binary missing.. DOH"
putei "Did you remember to install the main program ?"
putei ""
FAILCOUNT=1
fi
putei "Available ROMS -"
putei "$(find "$FATLOC"/roms -type f -maxdepth 1 | sed -e 's/\.\/roms\//''/' -e 's/\.[a-zA-Z]*$//' | tr '\x27' '\x32' )"
putei "$(find "$EXTLOC"/roms -type f -maxdepth 1 | sed -e 's/\.\/roms\///' -e 's/\/mnt\/us\/extensions\/gameboy\/roms\///' -e 's/\.[a-zA-Z]*$//' | tr '\x27' '\x32' )"
putei ""
putei "Execute Which ROM? Press Aa Key to SELECT"
putei "Just enter the filname, no extension."
putei "or just type q to quit the loader"
putei ""

game="$(getkb)"
if [ "$game" = "" ]
then
putei "RUNNING DEMO GAME as NO CHOICE entered"
sleep 2
fi
# EPIC FAIL. No Gnuboy
if [ ! "$FAILCOUNT" -lt 1 ] && [ ! "$game" = "q" ]
then
##
## After much deliberation this now contains a failsafe 1.0.3 version fbgnuboy binary "embedded".
## It will prefer the "latest" on in its own /mnt/us/fbgnuboy folder given the option.
## For the sake of 175kb a failsafe is more prefereable to failure.
##
## putei "Going to use failsafe. please install fbgnuboy"  <-- OPTIONAL DUMP POINT
##FAILCOUNT=1
putei "Going to use failsafe. please install fbgnuboy"
PROG="$EXTLOC"/bin/fbgnuboy-failsafe
##
## Rest failcount - this can be ripped out and the existing FAILCOUNT logic will dump the client as above
##
FAILCOUNT=0
## Let them read...
sleep 4
fi
if [ "$game" = "q" ]
then
killall -cont cvm launchpad 2> /dev/null
exit 0
fi
#draw picture frame
eips -g $EXTLOC/bin/gb-flash.jpg
usleep 50000
if [ "$game" = "" ] && [ "$HITCOUNT" -lt 1 ] && [ "$FAILCOUNT" -lt 1 ]
then
HOME=/tmp $PROG  $EXTLOC/roms/demo.gb* 2> $EXTLOC/gnuboy.log
HITCOUNT=1
fi
if [ -e ./roms/"$game".gb* ] && [ "$HITCOUNT" -lt 1 ]
then
HOME=/tmp $PROG ./roms/"$game".gb* 2> /mnt/us/fbgnuboy/gnuboy.log
HITCOUNT=1
fi
if [ -e $EXTLOC/roms/"$game".gb* ] && [ "$HITCOUNT" -lt 1 ]
then
HOME=/tmp $PROG $EXTLOC/roms/"$game".gb* 2> $EXTLOC/gnuboy.log
HITCOUNT=1
fi
# we made it this far... the game must not exist!
if [ "$HITCOUNT" -lt 1 ]
then
eips -c
putei "Meh. gamefile \"$game\" does not exist? Try again."
else
eips -c
game=""
if [ "$FAILCOUNT" -lt 1 ]
then
putei "type q to quit or anything else to continue"
putei "Press Aa Key to confirm your selection"
game="$(getkb)"
fi
if [ "$game" = "q" ] || [ ! "$FAILCOUNT" -lt 1 ]
then
eips -c
putei "Game Over :) Goodbye"
else
HITCOUNT=0
FAILCOUNT=0
eips -c
fi
fi
done
usleep 200000
killall -cont cvm launchpad 2> /dev/null
echo "send 102" > /proc/keypad; echo "send 102" > /proc/keypad

